use super::{RawDhcpOption, DhcpOptionError};
use crate::options::DhcpOption;
use core::net::Ipv4Addr;

pub struct HostNameOption;

impl DhcpOption for HostNameOption {
    const CODE: u8 = 12;
    type Item = String;

    fn parse(option: &RawDhcpOption) -> Result<Self::Item, DhcpOptionError> {
        let data = core::str::from_utf8(&option.data)?;
        Ok(data.to_string())
    }
}
